# !/usr/bin/perl -w

use constant TRUE => 1;
use constant FALSE => 0;

#Oblige de coder proprement et initialisation de GTK2
use strict;
use Gtk2 '-init';

################################
##           FENETRE          ##
################################
my $fenetre = Gtk2::Window->new('toplevel'); 			#Cration de la fentre
#$fenetre->set_default_size('600','400');			#Taille de la fentre
$fenetre->set_border_width(10) ; 				#Brodure  l'intrieur
$fenetre->set_title('Testeur de regex');			#Titre

$fenetre->signal_connect('delete_event',\&Close_Window,'tset');	#Signal de la croix
$fenetre->signal_connect('destroy',\&Destroy_Window); 		#Signal de fermeture

################################
##          WIDGETS           ##
################################

my $nom_regex = Gtk2::Label->new('Le regex  tester:                       ');  
$nom_regex->set_justify('left');

my $input_regex = Gtk2::Entry->new;
$input_regex->set_editable(TRUE);

my $effacer_regex = Gtk2::Button->new('Effacer'); 
$effacer_regex->signal_connect('clicked',sub{$input_regex->set_text('');}); 

my $nom_texte = Gtk2::Label->new('Le texte contenant l\'expression:');  
$nom_regex->set_justify('left');

my $input_texte = Gtk2::Entry->new;
$input_texte->set_editable(TRUE);

my $effacer_texte = Gtk2::Button->new('Effacer'); 
$effacer_texte->signal_connect('clicked',sub{$input_texte->set_text('');}); 

my $bouton_verifier = Gtk2::Button->new('Vrifier'); 
$bouton_verifier->signal_connect( 'clicked',\&verifier); 

my $aff_resultat = Gtk2::Entry->new;
$aff_resultat->set_editable(FALSE);

my $bouton_apropos = Gtk2::Button->new(' propos'); 
$bouton_apropos->signal_connect('clicked',\&apropos); 

my $bouton_quitter = Gtk2::Button->new('Quitter'); 
$bouton_quitter->signal_connect('clicked',\&Destroy_Window); 

################################
##   TABLEAU  DE LA FENETRE   ##
################################

my  $tableau = Gtk2::Table->new(8,5,TRUE);			#Cration du tableau
$fenetre->add($tableau); 					#Ajout du tableau  la fentre

$tableau->attach_defaults($nom_regex,0,1,0,1);			#Lier le widget au tableau
$nom_regex->show();						#Afficher le widget
$tableau->attach_defaults($input_regex,0,4,1,2); 		
$input_regex->show();						
$tableau->attach_defaults($effacer_regex,4,5,1,2); 
$effacer_regex->show();
$tableau->attach_defaults($nom_texte,0,1,2,3);			#Lier le widget au tableau
$nom_texte->show();
$tableau->attach_defaults($input_texte,0,4,3,4); 
$input_texte->show();
$tableau->attach_defaults($effacer_texte,4,5,3,4); 
$effacer_texte->show();
$tableau->attach_defaults($bouton_verifier,0,1,5,6);
$bouton_verifier->show(); 
$tableau->attach_defaults($aff_resultat,3,4,5,6);
$aff_resultat->show();
$tableau->attach_defaults($bouton_apropos,1,2,7,8);
$bouton_apropos->show();  
$tableau->attach_defaults($bouton_quitter,3,4,7,8);
$bouton_quitter->show();  

$tableau->show();						#Afficher le tableau


#Affiche la fentre et lance la boucle principale (obligatoire)
$fenetre->show;
Gtk2->main; 



################################
##         FONCTIONS          ##
################################

sub verifier {
my $regex = $input_regex->get_text;
my $regex = qr/$regex/i;
my $texte = $input_texte->get_text;
if ( $texte =~ $regex )
	{
		$aff_resultat->set_text('Le regex correspond !');
	}
else
	{
		$aff_resultat->set_text('Le regex ne correspond pas !');
	}
}

#A voir en dtail
sub apropos{
my $fenetre_apropos = Gtk2::Dialog->new(' propos',$fenetre,'destroy-with-parent','gtk-ok'=>'none');    
my $label = Gtk2::Label->new("Testeur de Regex v0.2 \n by Clockover (31/08/2006) \n Licence GPL");  
$fenetre_apropos->vbox->pack_start($label,TRUE,TRUE,0); 
$fenetre_apropos->set_modal(TRUE); 				#Rendre la fentre modale
$label->show();
$fenetre_apropos->show;

$fenetre_apropos->signal_connect (response => sub {$_[0]->destroy;});  
}

sub Close_Window {
return FALSE;
}

sub Destroy_Window {
Gtk2->main_quit ;
return FALSE;
}




